unit klient1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, StdCtrls, xmldom, XMLIntf, msxmldom, XMLDoc, ComCtrls;

type
  TForm1 = class(TForm)
    IdHTTP1: TIdHTTP;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    XMLDocument1: TXMLDocument;
    GroupBox2: TGroupBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    UpDown1: TUpDown;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Label7: TLabel;
    Edit5: TEdit;
    UpDown2: TUpDown;
    Label8: TLabel;
    Button2: TButton;
    GroupBox3: TGroupBox;
    TreeView1: TTreeView;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  node1, node2, node3: IXMLNode;
  i, j: integer;
begin
  Memo1.Lines.Clear;
  IdHTTP1.Connect;
  Memo1.Lines.Clear;
  Memo1.Lines.Add(IdHTTP1.Get('/SeznamStanic'));
  Memo1.Lines.SaveToFile('temp.xml');
  IdHTTP1.Disconnect;
  GroupBox2.Enabled := true;


  XMLDocument1.LoadFromFile('temp.xml');
  node1 := XMLDocument1.DocumentElement;
  ComboBox1.Items.Clear;
  ComboBox2.Items.Clear;
  ComboBox3.Items.Clear;
  ComboBox3.Items.Add('- - - nen zadno - - -');
  for i := 0 to node1.ChildNodes.Count - 1 do
  begin
    node2 := node1.ChildNodes[i];
    if node2.NodeName = 'Stanice' then
    begin
      ComboBox1.Items.Add(node2.NodeValue);
      ComboBox2.Items.Add(node2.NodeValue);
      ComboBox3.Items.Add(node2.NodeValue);
    end;
  end;
  if ComboBox1.Items.Count > 1 then
  begin
    ComboBox1.ItemIndex := 0;
    ComboBox2.ItemIndex := 1;
    ComboBox3.ItemIndex := 0;
  end;
end;

procedure NahradMezery(var t: string);
var
  i: integer;
begin
  for i := 1 to length(t) do if t[i] = ' ' then t[i] := '+';
end;

function odkaz(n: IXMLNode): string;
begin
  if n = nil then result := '' else result := n.NodeValue;
end;

procedure odkaz2(n: IXMLNode; var o: string);
begin
  if n <> nil then o := n.NodeValue;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  s, od, ka, pr: string;
  node1, node2, node3, node4: IXMLNode;
  i, j, k: integer;
  tnode1, tnode2, tnode3, tnode4: TTreeNode;
  prvnista, poslsta: string; //prvni, posledni stanice
  odjezd, prijezd: string;
  
begin
  od := ComboBox1.Items[ComboBox1.ItemIndex]; NahradMezery(od);
  ka := ComboBox2.Items[ComboBox2.ItemIndex]; NahradMezery(ka);
  pr := ComboBox3.Items[ComboBox3.ItemIndex]; NahradMezery(pr);

  if ComboBox3.ItemIndex = 0 then s := Format('odkud=%s&kam=%s&odjezd=%s&prestupy=%d&spojeni=%d HTTP/1.0', [od, ka, Edit4.Text, updown1.position, updown2.position])
  else s := Format('odkud=%s&kam=%s&pres=%s&odjezd=%s&prestupy=%d&spojeni=%d HTTP/1.0', [od, ka, pr, Edit4.Text, updown1.position, updown2.position]);
  IdHTTP1.Connect;
  //ShowMessage(s);

  Memo1.Lines.Clear;
  Memo1.Lines.Add(IdHTTP1.Get('/NajdiSpojeni?' + s));

  Memo1.Lines.SaveToFile('temp.xml');
  IdHTTP1.Disconnect;


  TreeView1.Items.Clear;
  XMLDocument1.LoadFromFile('temp.xml');
  node1 := XMLDocument1.DocumentElement;
  tnode1 := TreeView1.Items.Add(nil, '"'+ComboBox1.Items[ComboBox1.ItemIndex]+'" - "'+ComboBox2.Items[ComboBox2.ItemIndex]+'"');
  for i := 0 to node1.ChildNodes.Count - 1 do
  begin
    node2 := node1.ChildNodes[i];
    if node2.NodeName = 'Spoj' then
    begin
      if node2.ChildNodes.Count = 1 then tnode2 := TreeView1.Items.AddChild(tnode1, 'bez pestup')
      else tnode2 := TreeView1.Items.AddChild(tnode1, 'pestup: ' + IntToStr(node2.ChildNodes.Count - 1));
      // + node2.ChildNodes[0].AttributeNodes.FindNode('odjezd').NodeValue);
      odjezd := ''; prijezd := '';
      for j := 0 to node2.ChildNodes.Count - 1 do
      begin
        node3 := node2.ChildNodes[j];

        if node3.NodeName = 'Linka' then
        begin

          tnode3 := TreeView1.Items.AddChild(tnode2, 'Vlak ' + node3.AttributeNodes.FindNode('cislo').NodeValue);
//           + '"' + node3.ChildNodes[0].NodeValue + '" - "' + node3.ChildNodes[node3.ChildNodes.count-1].NodeValue + '"');
          prvnista := ''; poslsta := '';
          for k := 0 to node3.ChildNodes.Count - 1 do
          begin
            node4 := node3.ChildNodes[k];
            if node4.NodeName = 'Stanice' then
            begin
              if prvnista = '' then prvnista := node4.NodeValue;
              if odjezd = '' then odkaz2(node4.AttributeNodes.FindNode('odjezd'), odjezd);
              odkaz2(node4.AttributeNodes.FindNode('prijezd'), prijezd);
              poslsta := node4.NodeValue;
              tnode4 := TreeView1.Items.AddChild(tnode3, 'pjezd:'+odkaz(node4.AttributeNodes.FindNode('prijezd'))+' odjezd:'
              +odkaz(node4.AttributeNodes.FindNode('odjezd'))+ ' ' +node4.NodeValue);
            end;
          end;
          tnode3.Text :=tnode3.Text + ' "' + prvnista + '" - "' + poslsta + '"';

        end;
      end;
      tnode2.Text :='odjezd:'+odjezd+' pjezd:'+prijezd+ ' ' + tnode2.Text;


    end;
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  try
    IdHTTP1.Host := Edit1.Text;
    IdHTTP1.Port := StrToInt(Edit2.Text);
  except
    ShowMessage('Chybn slo portu');
  end;
end;

end.
